<?php 
// _config.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.

// Critical Information
// At the very least, you'll want to personalize these variables. 
// - The 'title' will be sent in the <TITLE> block, and will thus appear in
//   the title-bar of your users' Web browser
// - 'adminName' should be your name
// - 'adminPassword' PLEASE change this to be something unique
// - 'adminSig' will be attached to outgoing email messages (assuming you stick 
//   with the default text) on the mailing list
// - 'emailFrom' is the address from which QwikiWiki attributes its email
$QW_CONFIG['title']         = "QwikiWiki";
$QW_CONFIG['adminName']     = "David Barrett";
$QW_CONFIG['adminPassword'] = 'changeme!';
$QW_CONFIG['adminSig']      = "-david";
$QW_CONFIG['emailFrom']     = 'donotreply@qwikiwiki.com';

// Start Page
// Set this to be the name of the QuikiPage that is mapped to the "null" page
$QW_CONFIG['startPage'] = "Home";

// Global Navigation
// Depending on the template used, the Global Nav is a lis of key pages presented
// to the user as starting points for navigation.  This is an array of text blocks
// that will be run through the Wiki-parser.  Thus it can be any Qwiki page name,
// URL, HTML tag, etc.
$QW_CONFIG['globalNav'] = array(
	"_Home_", 
	"QwikiWiki",
	"QwikiSyntax",
	"<A HREF='recentchanges.php'>Recent Changes</A>"
);

// Wiki Locking
// For outward-facing Wikis, disables editing on pages that are not password-
// protected.  Enable this if you want to prevent all non-admin modifications.  
// This is a useful feature if you're using QwikiWiki to just create your own 
// personal website, and don't want to allow anyone else to edit it.  
// Alternatively, if leave the globalEditLock disabled, you can selectively
// protect pages from public editing by clicking the appropriate checkbox 
// while editing a page in admin mode (logged in with the admin password).
$QW_CONFIG['globalEditLock'] = false;

// Acceptable HTML Tags
// QwikiWiki allows users to insert HTML directly into page text, which is
// both good and bad.  The good part is this makes it really easy to manipulate
// the final output of the Wiki page.  The bad part is that unscrupulous users
// can insert bad code into your output pages.  With this in mind, QwikiWiki lets
// you strick your own balance between security and usability by specifying which
// HTML tags you'll allow users to use.  Simply insert new tags (or remove existing
// tags) from the 'acceptableHTMLTags' list below, as shown.
$QW_CONFIG['acceptableHTMLTags']  = '<a><b><i><u><img><code><pre><html><table><tr><td><div>';

// Edit Lockfile Expiration
// Specify the timeout duration for lockfiles.  If this is too short, people
// might lose the lock while still editing.  If this is too long, dead locks
// (from starting to edit and closing the window, for example) will block out
// legitimate editing.
$QW_CONFIG['editLockfileExpiration'] = 60 * 30; // a half hour

// QwikiTag Patterns
// Set this to be the list of word patterns to automatically treat as QwikiTags.
// Note, this the first matching pattern will be used as the display name of the 
// QwikiTag, the name of the QwikiPage, and also the name of the file on disk
// (after appending '.qwiki').  Thus, make sure you only match patterns that
// you want to visually display, and that make valid filenames.
$QW_CONFIG['tagPatternArray'] = array( 
	'/(^|[^\w_]+)([A-Z]+[a-z\d]+[A-Z]+\w*)($|[^\w_]+)/', // CamelBack
	'/(^|\W+)_([\w-]+(?:_[\w-]+)*)_($|\W+)/'     // Underscore
);

// Ignored QwikiTags
// One downside of all wikis is how they occasionaly tag words as links even
// when you don't want them to be.  If you find yourself suffering from this,
// add the offending word in the 'ignoreTagPatternArray' and it will never be
// be linked as a QwikiTag.
$QW_CONFIG['ignoreQwikiTagArray'] = array( 
	'DoNotLinkMe', 
	'Do_not_link_me', 
	'P2P', 'B2B', 'B2C'
);

// File Attachments
// If enabled, editors can upload files to a private directory created for that
// page.  Thus stored, typing the name of the file into the page source creates 
// a link to that file.  If the file happens to be an image (gif, jpg, png), 
// it will also be embedded inline.  For security reasons, you can set the list
// of acceptable file extensions (so as to prevent, say, PHP files from being
// uploaded).
$QW_CONFIG['enableAttach'] = true;
$QW_CONFIG['maxUploadSize'] = 2 * 1024 * 1024; // 2MB
$QW_CONFIG['acceptableExtensions'] = array( 'gif', 'jpg', 'zip', 'doc', 'txt' );

// Template
// Pick the filename of the PHP template used for output.  The following templates
// are supplied out-of-the-box:
// - _narrow_template.php - A 700-pixel fixed-width page with navigation at the bottom
//                          (mimics the QwikiWiki v1.2 layout)
// - _wide_template.php - A 100% variable-width page with navigation at the top
// - _widelogo_template.php - Same as _wide_template.php, but with space for a logo
$QW_CONFIG['templateFilename'] = '_widelogo_template.php';
$QW_CONFIG['templateLogo'] = 'qwikiwiki_logo.gif'; // used in _widelogo_template.php

// Stylesheet
// Pick the filename of the CSS stylesheet used to format the template.  The following
// stylesheets are supplied out-of-the-box:
// - _darkblue_style.css - Dark blue theme, used on www.qwikiwiki.com
// - _greenblack_style.css - Dark blue theme, used on www.quinthar.com
// - _lightblue_style.css - A muted, light-blue theme (default in v1.2 of QwikiWiki)
// - _bbs_style.css - A green-on-black theme loosely-reminiscnet of old-school BBSes
$QW_CONFIG['stylesheetFilename'] = '_darkblue_style.css';

// Email Options
// New in v1.4, QwikiWiki allows users to subscribe to individual pages to be notified
// when the page changes.  These notification messages follow file-based templates,
// both in text and HTML.  By default, the HTML page change notifications even embed
// the latest version of the page into the email itself.  To disable these page-changed
// mailing lists, set 'enableEmail' to false.  To force all email to be text (and not
// HTML), set 'enableEmailHTML' to be false.
//
// **WARNING** So far as I can tell, PHP has a bug on Win32 systems that prevents it
//             from sending HTML email.  In fact, it even appears to crash PHP when you
//             attempt to do so.  Thus, if you are running QwikiWiki on a Win32 server,
//             you are HIGHLY RECOMMENDED to test sending HTML email vigorously, and to
//             disable it otherwise.
//
$QW_CONFIG['emailEnable']     = true;
$QW_CONFIG['emailEnableHTML'] = true;

// Email templates
// All email sent follows template messages contained in the files named below.  These
// message templates embed the following system-inserted variables:
// - QW_HOMELINK        - URL of the QwikiWiki installation 
// - QW_PAGELINK        - URL of the page that changed
// - QW_TITLE           - Title of the page that changed
// - QW_PAGE            - Name of the page that changed
// - QW_CSS             - CSS contents of the current style
// - QW_BODYTEXT        - text (unformatted) contents of the page itself
// - QW_BODYHTML        - HTML contents of the page itself
// - QW_ADMINSIG        - Contents of QW['adminSig'], defined above
// - QW_UNSUBSCRIBELINK - URL to unsubscribe from the mailing list
// - QW_RESUBSCRIBELINK - URL to resubscribe to the mailing list
//
$QW_CONFIG['emailSubscribeSubject']            = "Subscribed to 'QW_PAGE' on QW_TITLE";
$QW_CONFIG['emailUnsubscribeSubject']          = "Unsubscribed from 'QW_PAGE' on QW_TITLE";
$QW_CONFIG['emailChangedSubject']              = "'QW_PAGE' changed on QW_TITLE";
$QW_CONFIG['emailSubscribeBodyTextFilename']   = "_subscribemessage.txt";
$QW_CONFIG['emailSubscribeBodyHTMLFilename']   = "_subscribemessage.html";
$QW_CONFIG['emailUnsubscribeBodyTextFilename'] = "_unsubscribemessage.txt";
$QW_CONFIG['emailUnsubscribeBodyHTMLFilename'] = "_unsubscribemessage.html";
$QW_CONFIG['emailChangedBodyTextFilename']     = "_changedmessage.txt";
$QW_CONFIG['emailChangedBodyHTMLFilename']     = "_changedmessage.html";

// Debugging
// Enable this if you want to allow "debug=true" to be added to any URI such
// as to output debugging information.
$QW_CONFIG['enableDebugging'] = false;

?>
