<?php 
// _global.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.

////////////////////////////////////////////////////////////////////////////////
//////////////////////// Verify Installation ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// If it's not already installed, QWRedirect to the installer
if( !is_file( "data/INSTALLCOMPLETE" ) )
{
	// Redirect to the installer
	$url = "http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']) . "/install.php";
	header("Location: $url" );
	?><P>Please wait, redirecting to <A HREF="<?php echo $url; ?>">here</A>.</P><?php
	exit;
}

////////////////////////////////////////////////////////////////////////////////
/////////////////////////// Include Libraries //////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
require_once( "_util.php" );
require_once( "_config.php" );
require_once( "_wikiLib.php" );
require_once( "_render.php" );
require_once( "_mailinglistLib.php" );
	
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////// Set Globals /////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Global variables
$QW['homeLink'] = "http://" . $_SERVER['HTTP_HOST'] . dirname($_SERVER['PHP_SELF']);
$homeLinkLength = strlen( $QW['homeLink'] );
if( $QW['homeLink'][$homeLinkLength-1] == '/' ) $QW['homeLink'] = substr( $QW['homeLink'], 0, $homeLinkLength-1 );
$QW['globalLockPath'] = 'data/GLOBALLOCK';

// Detect the input
if( count( $HTTP_GET_VARS ) ) $QW_REQUEST = $HTTP_GET_VARS;
else                          $QW_REQUEST = $HTTP_POST_VARS;
	
// Strip all the $QW_REQUEST_VAR slashes
if( count( $QW_REQUEST ) ) foreach( $QW_REQUEST as $name => $value )
	$QW_REQUEST[ $name ] = stripslashes( $value );

// Pick out the useful request vars
$QW['requestFrom']     = QWSafeGet( $QW_REQUEST, 'from' );
$QW['requestPage']     = QWSafeGet( $QW_REQUEST, 'page' );
$QW['requestAction']   = QWSafeGet( $QW_REQUEST, 'action' );
$QW['requestPassword'] = QWSafeGet( $QW_REQUEST, 'password' );
$QW['requestWikiData'] = QWSafeGet( $QW_REQUEST, 'wikidata' );
$QW['requestFilename'] = QWSafeGet( $QW_REQUEST, 'filename' );
$QW['requestDebug']    = QWSafeGet( $QW_REQUEST, 'debug' );
$QW['requestQuery']    = QWSafeGet( $QW_REQUEST, 'query' );
$QW['requestEmail']    = QWSafeGet( $QW_REQUEST, 'email' );
$QW['requestHTML']     = QWSafeGet( $QW_REQUEST, 'html' );
$QW['requestNotify']   = QWSafeGet( $QW_REQUEST, 'notify' );
$QW['requestHelp']     = QWSafeGet( $QW_REQUEST, 'help' );
$QW['requestProtect']  = QWSafeGet( $QW_REQUEST, 'protect' );

// Determine which page we're using:
if( !$QW['requestPage'] ) $QW['page'] = $QW_CONFIG['startPage'];
else                      $QW['page'] = $QW['requestPage'];

// Get the file associated with this page
$QW['pagePath']  = QWCreateDataPath( $QW['page'], '.qwiki' );
$QW['lockPath']  = QWCreateDataPath( $QW['page'], '.lock' );
$QW['passPath']  = QWCreateDataPath( $QW['page'], '.pass' );
$QW['mailPath']  = QWCreateDataPath( $QW['page'], '.mail' );
$QW['attachDir'] = QWCreateDataPath( $QW['page'], '_attach' );	
$QW['fromPagePath']  = ( $QW['requestFrom'] && $QW['requestFrom'] != $QW['page'] ) ? 
                   	 QWCreateDataPath( $QW['requestFrom'], '.qwiki' ) : 
                   	 "";
$QW['fromPassPath']  = ( $QW['requestFrom'] && $QW['requestFrom'] != $QW['page'] ) ? 
                   	 QWCreateDataPath( $QW['requestFrom'], '.pass' ) : 
                   	 "";
                   	
// Strip all the $HTTP_COOKIE_VARS slashes
QWStripArraySlashes( $HTTP_COOKIE_VARS );
	
// Pick out the useful cookie variables
$QW['cookiePassword']    = QWSafeGet( $HTTP_COOKIE_VARS, 'password' );
$QW['cookieRecentPages'] = QWSafeGet( $HTTP_COOKIE_VARS, 'recentpages' );
if( $QW['cookieRecentPages'] ) $QW['cookieRecentPageList'] = unserialize( $QW['cookieRecentPages'] );
else                           $QW['cookieRecentPageList'] = array( );

// See if the user is authenticated, implicitly or otherwise
$QW['encryptedPassword'] = md5( $QW_CONFIG['adminPassword'] );
$QW['pageIsProtected'] = $QW_CONFIG['globalEditLock'] || ( $QW['fromPassPath'] ? is_file( $QW['fromPassPath'] ) : is_file( $QW['passPath'] ) );
$QW['userIsAuthenticated'] = ($QW['cookiePassword'] == $QW['encryptedPassword']);

// Prepare to append URLs
$QW['debugURLSuffix'] = ( $QW['requestDebug'] ? "&debug=true" : "" );
$QW['helpURLSuffix'] = ( $QW['requestHelp'] ? "&help=true" : "" );
$QW['URLSuffix'] = $QW['debugURLSuffix'] . $QW['helpURLSuffix'];
$QW['hrefTarget'] = "";

// NoOp template functions
function QWNoOp( ) { }
$QW_TEMPLATE['getTitle'] = "QWNoOp";
$QW_TEMPLATE['injectBody'] = "QWNoOp";
$QW_TEMPLATE['commandList'] = "QWNoOp";

?>