<?php 
// _render.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.

// QWFormatIndent
function QWFormatIndent( $indent, $text )
{
	$result = "<TABLE CLASS='QWIndent' CELLPADDING='0' CELLSPACING='0'><TR>";
	while( $indent-- ) $result .= "<TD CLASS='QWIndent' WIDTH='25'>&nbsp;</TD>";
	$result .= "<TD CLASS='QWIndent' VALIGN='top' ALIGN='left'>$text</TD></TR></TABLE>";
	return $result;
}

// QWFormatMessage
function QWFormatMessage( $message )
{
	// Just output the message, if it's there
	if( isset( $message ) )
		echo "<TABLE CLASS='QWResultBox' ALIGN='center'><TR><TD VALIGN='top'><IMG SRC='exclamationicon.gif'/></TD><TD ALIGN='center'>$message</TD></TR></TABLE><BR/>\n";
}

// QWFormatHelp
function QWFormatHelp( $message, $url )
{
	// Toggle which one to show
	global $QW;
	if( $QW['requestHelp'] )
	{ ?>	
		<BR/>
		<TABLE WIDTH='50%' CLASS='QWHelpBox' ALIGN='center'>
		<TR>
			<TD VALIGN='top'><IMG SRC="questionicon.gif"/></TD>
			<TD>
				<?php echo $message ?>
				<DIV CLASS='QWHelpToggle' ALIGN='center'><A HREF='<?php echo $url.$QW['debugURLSuffix'] ?>'>(Hide help)</A></DIV>
			</TD>
		</TR>
		</TABLE>
		<BR/>
	<?php } else { ?>
		<DIV CLASS='QWHelpToggle' ALIGN='center'><A HREF='<?php echo $url.$QW['debugURLSuffix'] ?>&help=true'>(Show help)</A></DIV>
	<?php }
}

// QWFormatArray
function QWFormatArray( $name, &$array )
{
	// Output a titled table
	$out = "<b>$name</b>";
	if( is_array( $array ) )
		if( count( $array ) )
		{
			// Output the table
			$out .= "<table border=1>";
			foreach( $array as $name => $value )
				$out .= "<tr><td>$name</td><td>$value</td></tr>";
			$out .= "</table>";
		}
		else $out .= " is an empty array.<br/>";
	else $out .= " is not an array.<br/>";
	return $out;
}

// QWFormatDebug
function QWFormatDebug( )
{
	// Output lots of data
	global $HTTP_COOKIE_VARS, $QW, $QW_REQUEST, $HTTP_SERVER_VARS;
	$out  = QWFormatArray( "REQUEST_VARS", $QW_REQUEST );
	$out .= QWFormatArray( "QW", $QW );
	$out .= QWFormatArray( "HTTP_COOKIE_VARS", $HTTP_COOKIE_VARS );
	$out .= QWFormatArray( "HTTP_SERVER_VARS", $HTTP_SERVER_VARS );
	return $out;
}

// QWFormatRelativeDate
function QWFormatRelativeDate( $nowTimestamp, $thenTimestamp )
{
	// Compute the difference
	$numSeconds = $nowTimestamp - $thenTimestamp;
	$numMinutes = round( $numSeconds / 60 );
	$numHours   = round( $numSeconds / 60 / 60 );
	$numDays    = round( $numSeconds / 60 / 60 / 24 );
	$numWeeks   = round( $numSeconds / 60 / 60 / 24 / 7  );
	     if( $numSeconds <  60 ) return "moments ago";
	else if( $numMinutes ==  1 ) return "1 minute ago";
	else if( $numMinutes <  60 ) return "$numMinutes minutes ago";
	else if( $numHours   ==  1 ) return "1 hour ago";
	else if( $numHours   <  24 ) return "$numHours hours ago";
	else if( $numDays    ==  1 ) return "yesterday";
	else if( $numDays    <   7 ) return "$numDays days ago";
	else if( $numWeeks   ==  1 ) return "last week";
	else if( $numWeeks   <   4 ) return "$numWeeks weeks ago";
	else if( $numDays    < 365 ) return date( "F j", $thenTimestamp );
	else                         return "ages ago";
}

// QWFormatFileSize
function QWFormatFileSize( $size )
{
	// Return the appropriate result
	$numBytes = $size;
	$numKBytes = round( $numBytes / 1024 );
	$numMBytes = round( $numKBytes / 1024 );
	$numGBytes = round( $numMBytes / 1024 );
	     if( $numBytes  < 1024 ) return "$numBytes B";
	else if( $numKBytes < 1024 ) return "$numKBytes KB";
	else if( $numMBytes < 1024 ) return "$numMBytes MB";
	else                         return "$numGBytes GB";
}


?>