<?php 
// index.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.
require_once( "_global.php" );

////////////////////////////////////////////////////////////////////////////////
/////////////////////////// Update recent page list ////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Update the list of recently viewed pages
$recentlyViewedPages[] = $QW['page'];
if( isset( $QW['cookieRecentPageList'] ) ) $QW['cookieRecentPageList'] = array_merge( array( $QW['page'] ), $QW['cookieRecentPageList'] );
else                                       $QW['cookieRecentPageList'] = array( $QW['page'] );
$QW['cookieRecentPageList'] = QWUnduplicateArray( $QW['cookieRecentPageList'] );
QWTruncateArrayInPlace( $QW['cookieRecentPageList'], 20 ); // only keep a history of 20 pages
setcookie( "recentpages", serialize( $QW['cookieRecentPageList'] ), time()+60*60*24*30 );

////////////////////////////////////////////////////////////////////////////////
///////////////////////////////// Disable Caching //////////////////////////////
////////////////////////////////////////////////////////////////////////////////
QWDisableCaching( );

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Define Template Functions /////////////////////////
////////////////////////////////////////////////////////////////////////////////

// QWTIndexFormatGlobalNav
$QW_TEMPLATE['getGlobalNavPageNameList'] = "QWTIndexFormatGlobalNav";
function QWTIndexFormatGlobalNav( )
{
	// Output from the config file
	global $QW_CONFIG;
	return QWFormatQwikiText( $QW_CONFIG['globalNav'] );
}

// QWTIndexFormatTitle
$QW_TEMPLATE['getTitle'] = "QWTIndexFormatTitle";
function QWTIndexFormatTitle( )
{
	// Output a title
	global $QW;
	return QWCleanQwikiPageName( $QW['page'] );
}

// QWTIndexFormatBody
$QW_TEMPLATE['injectBody'] = "QWTIndexFormatBody";
function QWTIndexFormatBody( )
{
	// Output the body
	global $QW;
	return QWFormatQwikiFile( $QW['pagePath'] );
}

// QWTIndexFormatCommandList
$QW_TEMPLATE['commandList'] = "QWTIndexFormatCommandList";
function QWTIndexFormatCommandList( )
{	
	// Compose the authentication commands
	global $QW, $QW_CONFIG, $HTTP_SERVER_VARS;	
	if( $QW['userIsAuthenticated'] ) $commandList[] = "<A HREF='logout.php?page=$QW[page]$QW[URLSuffix]'>Logout</A>";
	else                             $commandList[] = "<A HREF='login.php?page=$QW[page]$QW[URLSuffix]'>Login</A>";
		
	// Compose the editing commands
	if( $QW['requestFrom'] ) $fromSuffix = "&from=$QW[requestFrom]";
	else                     $fromSuffix = "";
	if( !$QW['pageIsProtected'] || $QW['userIsAuthenticated'] )
		if( QWLockExists( $QW['lockPath'] ) ) 
			if( QWHoldsLockfile( $QW['globalLockPath'], $QW['lockPath'], $HTTP_SERVER_VARS['REMOTE_ADDR'] ) )
			      $commandList[] = "<A HREF='edit.php?page=$QW[page]$fromSuffix$QW[URLSuffix]'>(Continue editing this page)</A>";
			else  $commandList[] = "(Page is being edited)";
		else          $commandList[] = "<A HREF='edit.php?page=$QW[page]$fromSuffix$QW[URLSuffix]'>Edit this page</A>";
	
	// Compose the subscription command
	if( $QW_CONFIG['emailEnable'] ) $commandList[] = "<A HREF='mailinglist.php?page=$QW[page]$QW[URLSuffix]'>$QW[page] mailing list</A>";
	return $commandList;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////// Fill Template ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Include the template
include( $QW_CONFIG['templateFilename'] );

// Output debugging, if requested
if( $QW_CONFIG['enableDebugging'] && $QW['requestDebug'] ) echo QWFormatDebug( );

?>