<?php 
// install.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Process Request Variables /////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Detect the input
if( count( $HTTP_GET_VARS ) ) $QW_REQUEST = $HTTP_GET_VARS;
else                          $QW_REQUEST = $HTTP_POST_VARS;
	
// Strip all the $QW_REQUEST_VAR slashes
if( count( $QW_REQUEST ) ) foreach( $QW_REQUEST as $name => $value )
	$QW_REQUEST[ $name ] = stripslashes( $value );
	
// QWSafeGet
function &QWSafeGet( &$varArray, $varIndex )
{
	// If it's set, return the value, else return zero
	if( isset( $varArray[$varIndex] ) ) return $varArray[$varIndex];
	else                                return false;
}

// Pick out the useful request vars
$QW['requestAction']       = QWSafeGet( $QW_REQUEST, 'action' );
$QW['requestButton']       = QWSafeGet( $QW_REQUEST, 'button' );
$QW['requestTo']           = QWSafeGet( $QW_REQUEST, 'to' );
$QW['requestSubject']      = QWSafeGet( $QW_REQUEST, 'subject' );
$QW['requestMessage']      = QWSafeGet( $QW_REQUEST, 'message' );
$QW['requestName']         = QWSafeGet( $QW_REQUEST, 'name' );
$QW['requestEmail']        = QWSafeGet( $QW_REQUEST, 'email' );
$QW['requestWhyQwiki']     = QWSafeGet( $QW_REQUEST, 'whyqwiki' );
$QW['requestOtherWikis']   = QWSafeGet( $QW_REQUEST, 'otherwikis' );
$QW['requestLearnQwiki']   = QWSafeGet( $QW_REQUEST, 'learnqwiki' );
$QW['requestAnnounceList'] = QWSafeGet( $QW_REQUEST, 'announcelist' );
$QW['requestDiscussList']  = QWSafeGet( $QW_REQUEST, 'discusslist' );
$QW['sendagent']           = QWSafeGet( $QW_REQUEST, 'sendagent' );
$QW['sendsignature']       = QWSafeGet( $QW_REQUEST, 'sendsignature' );
$QW['sendos']              = QWSafeGet( $QW_REQUEST, 'sendos' );
$QW['sendversion']         = QWSafeGet( $QW_REQUEST, 'sendversion' );
$QW['sendsafemode']        = QWSafeGet( $QW_REQUEST, 'sendsafemode' );
$QW['senduploads']         = QWSafeGet( $QW_REQUEST, 'senduploads' );

// Rewrite the action
if( !$QW['requestAction'] ) $QW['requestAction'] = 'Welcome';

// If it's already been installed, note this
if( is_file( "data/INSTALLCOMPLETE" ) ) $QW['requestAction'] = 'Installed';

////////////////////////////////////////////////////////////////////////////////
////////////////////////// Helper Function /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// testDir
function testDir( $dir )
{
	// Return the results
	if( !is_dir( $dir ) ) return "<DIV CLASS='QWError'>Error - <CODE>$dir</CODE> directory does not exist</DIV>";
	
	// Try to create a file in it
	$testPath = "$dir/test.txt";
	$fp = @fopen( $testPath, "w" );
	if( !$fp ) return "<DIV CLASS='QWError'>Error - Cannot write to <CODE>$dir</CODE> directory</DIV>";
	fclose( $fp );
	unlink( $testPath );
	
	// Try to create a subdirectory
	$testDir = "$dir/testDir";
	$stats = stat( $dir );
	$mode = $stats[2];
	if( !@mkdir( $testDir, $mode ) ) return "<DIV CLASS='QWError'>Error - Cannot create subdirectory in <CODE>$dir</CODE></DIV>";
	
	// Try to create a file in the subdirectory
	$testPath = "$dir/testDir/test.txt";
	$fp = @fopen( $testPath, "w" );
	if( !$fp )
	{
		// Remove the directory
		rmdir( $testDir );
		return "<DIV CLASS='QWError'>Error - Cannot write to subdirectory in <CODE>$dir</CODE></DIV>";
	}
	fclose( $fp );
	unlink( $testPath );
	
	// Remove the subdirectory
	if( !@rmdir( $testDir ) ) return "<DIV CLASS='QWError'>Error - Cannot delete subdirectory in <CODE>$dir</CODE></DIV>";
	
	// Works great!
	return "OK";
}

// testLock
function testLock( $path )
{
	// Try to open and lock
	$fp = @fopen( $path, "w+" );
	if( !$fp ) return "<DIV CLASS='QWError'>Error - Could not open for writing</DIV>";
	if( !@flock( $fp, LOCK_EX ) )
	{
		// Clean up and return an error
		fclose( $fp );
		return "<DIV CLASS='QWError'>Error - Could not lock</DIV>";
	}
	if( !@flock( $fp, LOCK_UN ) )
	{
		// Clean up and return an error
		fclose( $fp );
		return "<DIV CLASS='QWError'>Error - Could not unlock</DIV>";
	}
	fclose( $fp );
	return "OK";
}

////////////////////////////////////////////////////////////////////////////////
/////////////////////////////// Output the HTML ////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
?>
	<HEAD>
		<TITLE>QwikiWiki - Installer</TITLE>
		<STYLE>
			<!-- 
				body {
					font-family:Tahoma;
				}
				
				form {
					padding:0; 
					border:0; 
					margin:0
				}
				
				div.QWError {
					color: red;
				}
					
				div.QWGlobalNav {
					font-size:10.0pt; 
				}	
				
				div.QWTitleBox {
					border:solid windowtext 1.0pt; 
					border-color: black; 
					background: #0000ff; 
					color:white;
					margin-top:0pt;
					margin-bottom:0pt;
					font-size:16.0pt; 
					font-weight:bold; 
				}

				.QWTitleBox a:link {
					color:white;
				}
				.QWTitleBox a:visited {
					color:white;
				}
				.QWTitleBox a:hover {
					color:red;
				}
				
				div.QWFooterBox {
					border:solid windowtext 1.0pt; 
					border-color: black; 
					background: #0000ff; 
					color:white;
					margin-top:0pt;
					margin-bottom:0pt;
					font-size:16.0pt; 
					font-weight:bold; 
					height: 10pt;
				}

				div.QWCommandList {
					font-size:10.0pt; 
				}	
				
				table.QWResultBox {
					border:solid windowtext 1.0pt; 
					border-color: black; 
					background: #ffffaa; 
					font-size:10.0pt; 
				}
				
				table.QWHelpBox {
					border:solid windowtext 1.0pt; 
					border-color: black; 
					background: #ddddff; 
					font-size:10.0pt; 
				}
				
				div.QWHelpToggle {
					font-size:10.0pt; 
				}	
				
				
				table.QWInnerSection {
					color:black;
					font-family:Tahoma; 
					font-size:10.0pt;
					align: center;
				}
				
				tr.QWInnerSectionTitle {
					border:solid windowtext 1.0pt; 
					background:blue; 
					color:white;
					font-family:Tahoma; 
					font-weight:bold; 
				}
				
				div.QWNormal {
					margin-left:12pt;
					margin-right:12pt;
					margin-top:2.0pt;
					margin-bottom:2.0pt;
					font-size:12.0pt;
				}
				
				div.QWHeading1 {
					margin-left:12pt;
					margin-right:12pt;
					margin-top:6.0pt;
					margin-bottom:6.0pt;
					border-bottom:solid windowtext 1.0pt;
					border-bottom-color:blue;
					color:blue;
					font-size:14.0pt; 
					font-weight:bold; 
					text-align:left;
					}
			-->
		</STYLE>
	</HEAD>
	
	<BODY>
		<DIV CLASS='QWCommandList' ALIGN='right'>
			<A HREF='install.php?action=Welcome'>Welcome</A> |
			<A HREF='install.php?action=Environment'>Environment</A> |
			<A HREF='install.php?action=FileSystem'>File System</A> |
			<A HREF='install.php?action=Upload'>Upload</A> |
			<A HREF='install.php?action=Email'>Email</A> |
			<A HREF='install.php?action=Registration'>Registration</A>			
		</DIV>
		<TABLE ALIGN='center' WIDTH='100%'><TR><TD>
			<TABLE WIDTH='100%'><TR>
				<TD><IMG SRC='qwikiwiki_logo.gif' BORDER='0'/></TD>
				<TD WIDTH='100%'><DIV CLASS='QWTitleBox' ALIGN='center'><DIV CLASS='QWTitle'>Installation: <?php echo $QW['requestAction'] ?></DIV></DIV></TD>
			</TR></TABLE>
<?php

// Choose the appropriate installation step
$commandHTML = "";
switch( $QW['requestAction'] )
{
	//////////////////////// Already Installed ////////////////////
	case 'Installed' : ?>
		<DIV CLASS='QWHeading1'>QwikiWiki has Already Been Installed</DIV>
		<DIV CLASS='QWNormal'>
			You have already installed QwikiWiki.  To re-install, delete the file
			named <I>INSTALLCOMPLETE</I> from your QwikiWiki <CODE>data/</CODE> directory.
			Click below to visit your QwikiWiki:
		</DIV>
		<BR/>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='index.php'>Click here to visit your QwikiWiki!</A></DIV>
		<BR/><?php
		break;		
		
	//////////////////////// Welcome ////////////////////
	case 'Welcome' :
	default : ?>
		<DIV CLASS='QWHeading1'>Welcome to QwikiWiki!</DIV>
		<DIV CLASS='QWNormal'>
			Thank you for installing QwikiWiki, the minimalist PHP wiki engine!  If you can
			read this page, you're well on your way to using QwikiWiki for your personal
			or commercial needs.  However, though I've taken utmost care to make installation
			as painless as possible, let's make sure everything is in order before getting
			started.  To this end, this wizard will walk you through the following process:
			
			<OL><LI>Test your Web hosting environment for compatibility with QwikiWiki's base
			requirements</LI>
			<LI>Verify you have created the necessary directory structure to store QwikiWiki data and backups</LI>
			<LI>Confirm your Web server is correctly configured to upload files and send email</LI>
			<LI>Register this installation of QwikiWiki, for free!</LI></OL>
			
			To use this installation wizard, just follow on the link at the bottom of the page.  To go forward and back,
			or to re-execute the same test, click the links to the lower-right corner.
			To jump backwards or forwards to any other page, click the links to the upper-right.  In the 
			meantime, click the link below to get started.
		</DIV>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Environment'>Click here to get started!</A></DIV>
		<BR/>
		<DIV CLASS='QWNormal'>
			(Alternatively, should you wish to skip this installation wizard, you can
			 <A HREF='install.php?action=ManualInstall'>manually install QwikiWiki using the following instructions</A>.)
		</DIV>
		<?php

		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=Environment'>Next: Environment Test</A>";
		break;		
		
	//////////////////////// Manual ////////////////////
	case 'ManualInstall' : ?>
		<DIV CLASS='QWHeading1'>Manual Installation Instructions</DIV>
		<DIV CLASS='QWNormal'>
			To manually install QwikiWiki, perform the following steps:
			<UL>
			<LI><B>Step 1: Confirm Environmental Compatibility</B> - QwikiWiki was designed to operate on PHP version
			4 and greater.  QwikiWiki might work unpredictably or not at all on earlier versions of PHP.  Also,
			QwikiWiki will by default send HTML mail, which appears to not work on Windows servers.  See <CODE>_config.php</CODE>
			to disable HTML email if this occurs.<BR/><BR/></LI>
			<LI><B>Step 2: Prepare File System</B> - QwikiWiki requires two subdirectories, named <CODE>data/</CODE>
			and <CODE>backup/</CODE>.  Your web server must be given permission to create, modify, and delete files and
			directories in each to operate correctly (this might require setting 0777 privileges on the directories and
			contained files).  In the <CODE>data/</CODE> directory you must create two files,
			both of which are editable by the Web server, named <CODE>GLOBALLOCK</CODE> and <CODE>INSTALLCOMPLETE</CODE>.<BR/><BR/></LI>
			<LI><B>Step 3: Confirm Email-Sending Capability</B> - A new feature in v1.4 of QwikiWiki is the capability for
			users to "subscribe" to a page-specific change-notification mailing list.  This list sends in both HTML 
			and text, depending on the user's preferences.  Verify that your PHP environment is correctly configured
			to send email.<BR/><BR/></LI> 
			<LI><B>Step 4: Confirm File Uploads</B> - Should you wish it, QwikiWiki allows users to upload and "attach" files
			to QwikiWiki pages.  Verify that file uploading is enabled on your Web server and PHP.  If uploading is not
			enabled (or you do not want to allow it), specify as much in <CODE>_config.php</CODE>.<BR/><BR/></LI>
			<LI><B>Step 5: Seed Your Data</B> - Included with the QwikiWiki installation is a subdirectory named
			<CODE>installdata/</CODE>, which contains help and sample files to jump-start your QwikiWiki installation.
			Copy these files to your the <CODE>data/</CODE> directory you created in step 2, and then set their permissions
			such that your Web server can edit and overwrite them.<BR/><BR/></LI>
			<LI><B>Step 6: Register Your Installation</B> - The final step is to register for the <A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-announce' TARGET='_blank'>QwikiWiki-Announce</A> and
			<A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-discuss' TARGET='_blank'>QwikiWiki-Discuss</A> mailing lists, as well as to simply let me know who you are and why
			you want to use QwikiWiki.  Feel free to email your thoughts to <A HREF='mailto:dbarrett@quinthar.com'>David
			Barrett (dbarrett@quinthar.com)</A>.  I'd love to hear from you!</LI>
			</UL>
			Once all that is complete, just click on the link below to visit your newly-installed site!
		</DIV>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='index.php'>Click here to visit your QwikiWiki</A></DIV>
		<?php

		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=Welcome'>Back: Back to Welcome</A> | <A HREF='index.php'>Finish</A>";
		break;		
	//////////////////////// Test Environment ////////////////////
	case 'Environment' : 
		// Get the directory
		$path = $HTTP_SERVER_VARS['PATH_TRANSLATED'];
		$info = pathinfo( $path );
		$installDir = $info[ 'dirname' ];
		
		// Test the operating system
		$winOS = preg_match( '/win/i', php_uname( ) );
	
		// Output the tables
		?><DIV CLASS='QWHeading1'>Test Hosting Environment</DIV>
		<DIV CLASS='QWNormal'>
			If you've come this far, chances are you're all set to go.  But just be
			sure (and for your information), let's figure out what kind of Web
			hosting environment you're using:
		</DIV>
		<BR/>
		<TABLE ALIGN='center' CLASS='QWInnerSection'>
			<TR CLASS='QWInnerSectionTitle'><TD>Server Setting</TD><TD>Value</TD><TD>Result</TD></TR>
			<TR><TD ALIGN='right'>Server Name:</TD><TD><?php echo $HTTP_SERVER_VARS['SERVER_NAME']  ?></TD><TD>OK</TD></TR>
			<TR><TD ALIGN='right'>Server Signature:</TD><TD><?php echo $HTTP_SERVER_VARS['SERVER_SIGNATURE']  ?></TD><TD>OK</TD></TR>
			<TR><TD ALIGN='right'>Server Port:</TD><TD><?php echo $HTTP_SERVER_VARS['SERVER_PORT']  ?></TD><TD><?php echo ($HTTP_SERVER_VARS['SERVER_PORT'] == 80 ? "OK" : "Warning - Untested on any port but 80") ?></TD></TR>
			<TR><TD ALIGN='right'>Server OS:</TD><TD><?php echo php_uname( ) ?></TD><TD><?php echo ($winOS ? "<DIV CLASS='QWError'>Warning - HTML email might not work correctly under Windows,<BR/> see <I>_config.php</I> to disable</DIV>" : "OK" ) ?></TD></TR>
			<TR><TD ALIGN='right'>Install Directory:</TD><TD><?php echo $installDir ?></TD><TD>OK</TD></TR>
		</TABLE>
		<BR/>
		<TABLE ALIGN='center' CLASS='QWInnerSection'>
			<TR CLASS='QWInnerSectionTitle'><TD>PHP Setting</TD><TD>Value</TD><TD>Result</TD></TR>
			<TR><TD ALIGN='right'>PHP Version:</TD><TD><?php echo PHP_VERSION  ?></TD><TD><?php echo ( PHP_VERSION > "4" ? "OK" : "Warning - Potentially unsupported PHP version")  ?></TD></TR>
			<TR><TD ALIGN='right'>Safe Mode:</TD><TD><?php echo (ini_get( 'safe_mode' ) ? "On" : "Off")  ?></TD><TD>OK</TD></TR>
			<TR><TD ALIGN='right'>File Uploads:</TD><TD><?php echo (ini_get( 'file_uploads' ) ? "On" : "Off")  ?></TD><TD><?php echo (ini_get( 'file_uploads') ? "OK" : "<DIV CLASS='QWError'>Warning - File uploads disabled</DIV>") ?></TD></TR>
			<TR><TD ALIGN='right'>File Upload Size Limit:</TD><TD><?php echo ini_get( 'upload_max_filesize' ) ?></TD><TD>OK</TD></TR>
		</TABLE>
		<BR/>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=FileSystem'>Click here to continue</A></DIV>		
		<?php

		// Set the navigation		
		$commandHTML = "<A HREF='install.php'>Back: Welcome</A> | <A HREF='install.php?action=Environment'>Redo Environment Test</A> | <A HREF='install.php?action=FileSystem'>Next: File System Test</A>";
		break;
		
		
	//////////////////////// Test Directories ////////////////////
	case 'FileSystem' : 
		// Create the directories
		$path = $HTTP_SERVER_VARS['PATH_TRANSLATED'];
		$info = pathinfo( $path );
		$installDir = $info[ 'dirname' ];
		$dataDir = "$installDir/data";
		$backupDir = "$installDir/backups";
		$globallockPath = "$installDir/data/GLOBALLOCK";
		
		// Try to create the directories, if they're not there
		$stats = stat( '.' );
		$mode = $stats[2];
		$message = "";
		if( !is_dir( $dataDir ) ) 
			if( @mkdir( $dataDir, $mode ) ) $message .= "Created <B>'$dataDir'</B><BR/>\n";
			else                           $message .= "Error - Could not create <B>'$dataDir'</B><BR/>\n";
		if( !is_dir( $backupDir ) ) 
			if( @mkdir( $backupDir, $mode ) ) $message .= "Created <B>'$backupDir'</B><BR/>\n";
			else                             $message .= "Error - Could not create <B>'$backupDir'</B><BR/>\n";
		if( !is_file( $globallockPath ) )
			if( @touch( $globallockPath ) ) $message .= "Created <B>'$globallockPath'</B><BR/>\n";
			else                           $message .= "Error - Could not create <B>'$globallockPath</B><BR/>\n";
		
		// Output the HTML	
		?><DIV CLASS='QWHeading1'>Test File System</DIV>
		<DIV CLASS='QWNormal'>
			Next we need to verify that you've created the necessary directory
			structure for QwikiWiki to manage its files.  Specifically, QWikiWiki needs write-access
			to the following two subdirectories: <I>/data</I> and <I>/backup</I>.  Also, we need to test
			our ability to lock the global lockfile, which is used to avoid simultaneous editing of the 
			same page.  Let's test each of these now:
		</DIV>
		<BR/>
		<TABLE WIDTH='50%' CLASS='QWHelpBox' ALIGN='center'>
		<TR>
			<TD VALIGN='top'><IMG SRC="questionicon.gif"/></TD>
			<TD>If you are using a Unix server, you might need to create QwikiWiki's directories
			manually.  Specifically, you need to create <CODE>data/</CODE> and <CODE>backups/</CODE>
			subdirectories in the QwikiWiki installation directory, and assign them permissions such
			that your Web server can create and modifies files and subdirectories inside each.  			
			Contact your system administrator to determine precisely how to do this on
			your server.<BR/>
			<BR/>
			However, if all else fails, you can execute the following commands in the 
			QwikiWiki installation directory.  This will create the <CODE>data/</CODE> and <CODE>backup/</CODE> 
			directories and assign everyone global write privileges:
<PRE>mkdir data
mkdir backups
chmod 0777 data
chmod 0777 backups</PRE>
			Of course, <B><I>NEVER</I></B> execute arbitrary Unix commands merely because someone
			told you to do it, unless you understand exactly what they'll do.  Thus if you have any
			doubt about the purpose of the above commands, please contact someone "in the know".
			</TD>
		</TR>
		</TABLE>
		<BR/>
		<?php if( $message ) { ?>
			<BR/>
			<TABLE CLASS='QWResultBox' ALIGN='center'>
				<TR><TD VALIGN='top'><IMG SRC='exclamationicon.gif'/></TD><TD><?php echo $message ?></TD></TR>
			</TABLE>
		<?php } ?>
		<BR/>
		<TABLE ALIGN='center' CLASS='QWInnerSection'>
			<TR CLASS='QWInnerSectionTitle'><TD>Test</TD><TD>Value</TD><TD>Result</TD></TR>
			<TR><TD ALIGN='right'>Installation Directory:</TD><TD><?php echo $installDir ?></TD><TD>OK</TD></TR>
			<TR><TD ALIGN='right'>Data Directory:</TD><TD><?php echo $dataDir ?></TD><TD><?php echo testDir( $dataDir )  ?></TD></TR>
			<TR><TD ALIGN='right'>Backup Directory:</TD><TD><?php echo $backupDir ?></TD><TD><?php echo testDir( $backupDir )  ?></TD></TR>
			<TR><TD ALIGN='right'>Global Lockfile:</TD><TD><?php echo $globallockPath ?></TD><TD><?php echo testLock( $globallockPath )  ?></TD></TR>
		</TABLE>
		<BR/>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Upload'>Click here to continue</A></DIV>		
		<?php
		
		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=Environment'>Back: Environment Test</A> | <A HREF='install.php?action=FileSystem'>Redo File System Test</A> | <A HREF='install.php?action=Upload'>Next: File Upload Test</A>";
		break;
		
	//////////////////////// Upload Files ////////////////////
	case 'Upload' :
		if( ini_get( 'file_uploads' ) )
		{
			// Output the HTML	
			?><DIV CLASS='QWHeading1'>Test File Uploading</DIV>
			<DIV CLASS='QWNormal'>
				One of QwikiWiki's nicer features is the ability to "attach" files to a page by uploading
				through your Web browser.  Let's make sure that works now.  For this test, click on the
				<B>Browse</B> button below and pick any file off your hard drive, and then click <B>Upload</B>.
				This will upload a file from your Web browser to the Web server, into a temporary directory.
				<UL><LI>To be on the safe side,
				be sure to pick a file that has no confidential or sensitive information on it -- QwikiWiki
				doesn't encrypt files as they're uploaded or stored.</LI></UL>
				Redo this test a couple times with a variety of file sizes to make sure it works well (though
				your webserver is configured to reject anything over <B><?php echo ini_get( 'upload_max_filesize' )?></B>,
				beyond which it might behave unpredictably).
			</DIV>
			<BR/><?php
			
			// See if anything uploaded
			if( isset( $HTTP_POST_FILES[ 'userfile' ] ) && $HTTP_POST_FILES[ 'userfile' ][ 'size' ] )
			{
				// File uploaded
				?><TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>File Attribute</TD><TD>Value</TD><TD>Result</TD></TR>
					<TR><TD ALIGN='right'>Name:</TD><TD><?php echo $HTTP_POST_FILES[ 'userfile' ][ 'name' ] ?></TD><TD>OK</TD></TR>
					<TR><TD ALIGN='right'>Type:</TD><TD><?php echo $HTTP_POST_FILES[ 'userfile' ][ 'type' ] ?></TD><TD>OK</TD></TR>
					<TR><TD ALIGN='right'>Size:</TD><TD><?php echo $HTTP_POST_FILES[ 'userfile' ][ 'size' ] ?> bytes</TD><TD>OK</TD></TR>
					<TR><TD ALIGN='right'>Temp Name:</TD><TD><?php echo $HTTP_POST_FILES[ 'userfile' ][ 'tmp_name' ] ?></TD><TD>OK</TD></TR>
				</TABLE>
				<BR/><?php
				
				// Delete the temp file
				unlink( $HTTP_POST_FILES[ 'userfile' ][ 'tmp_name' ] );
			}
			
			?><DIV ALIGN='center'>
				<FORM CLASS='QWForm' ENCTYPE="multipart/form-data" METHOD="post" ACTION="install.php">
					<INPUT TYPE="hidden" NAME="action" VALUE="Upload"/>
					<INPUT TYPE="hidden" NAME="MAX_FILE_SIZE" VALUE="2000000"/>
					<INPUT SIZE="40" TYPE="file" NAME="userfile"/><INPUT TYPE="submit" NAME="blah" VALUE="Upload File"/>
				</FORM>
			</DIV>			
			<BR/>
			<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Email'>Click here to continue</A></DIV>		
			<?php
		}
		else
		{
			// Output the HTML	
			?><DIV CLASS='QWHeading1'>File Uploading Disabled!</DIV>
			<DIV CLASS='QWNormal'>
				Unfortunately, your Web server is configured to disallow file uploading.  Please
				contact your system administrator (or modify the <I>php.ini</I> file) to set <I>file_uploads = On</I>, and
				then try again.
			</DIV>
			<BR/>
			<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Email'>Click here to skip testing file uploads</A></DIV>		
			<?php
		}
		
		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=FileSystem'>Back: File System Test</A> | <A HREF='install.php?action=Upload'>Redo Upload Test</A> | <A HREF='install.php?action=Email'>Next: Email Test</A>";
		break;

	//////////////////////// Email Sending //////////////////		
	case 'Email' :
		// Output the HTML	
		?><DIV CLASS='QWHeading1'>Test Email Sending</DIV>
		<DIV CLASS='QWNormal'>
			New in v1.4, QwikiWiki allows people to subscribe to <I>mailing lists</I> on a per-page basis.
			Whenever anyone changes the page, everyone on the mailing list is notified.  To make sure this
			feature will work for you, let's test our ability to send email now.  Type an email address
			and message into the fields below, and then click <B>Send</B> to send the email.
		</DIV>
		<BR/><?php
		
		// Send, if necessary
		if( strlen( $QW['requestTo'] ) )
		{
			// Send the email
			if( @mail( $QW['requestTo'], $QW['requestSubject'], $QW['requestMessage'], "From: qwikiwiki@$HTTP_SERVER_VARS[SERVER_NAME]" ) )
				$message = "Email sent to <B>$QW[requestTo]</B>, please verify that it arrived safely.";
			else
				$message = "Error - Cannot send mail";	
				
			// Output the results
			?><TABLE CLASS='QWResultBox' ALIGN='center'>
			<TR><TD VALIGN='top'><IMG SRC='exclamationicon.gif'/></TD><TD><?php echo $message ?></TD></TR>
			</TABLE>
			<BR/><?php
		}

		?><FORM CLASS='QWForm' ENCTYPE="multipart/form-data" METHOD="post" ACTION="install.php">
			<INPUT TYPE='hidden' NAME='action' VALUE='Email'/>
			<TABLE ALIGN='center' CLASS='QWInnerSection'>
				<TR CLASS='QWInnerSectionTitle'><TD>Header</TD><TD>Value</TD></TR>
				<TR><TD ALIGN='right'>From:</TD><TD><?php echo "qwikiwiki@$HTTP_SERVER_VARS[SERVER_NAME]" ?></TD></TR>
				<TR><TD ALIGN='right'>To:</TD><TD><INPUT TYPE='text' NAME='to' VALUE='<?php echo $QW['requestTo'] ?>'/></TD></TR>
				<TR><TD ALIGN='right'>Subject:</TD><TD><INPUT TYPE='text' NAME='subject' VALUE='<?php echo $QW['requestSubject'] ?>'/></TD></TR>
				<TR><TD ALIGN='right'>Message:</TD><TD><INPUT TYPE='text' NAME='message' VALUE='<?php echo $QW['requestMessage'] ?>'/></TD></TR>
				<TR><TD ALIGN='right'></TD><TD><INPUT TYPE="submit" NAME="blah" VALUE="Send"/></TD></TR>
			</TABLE>
		</FORM>
		<BR/>
		<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Registration'>Click here to continue</A></DIV>		
		<?php
		
		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=Upload'>Back: Upload Test</A> | <A HREF='install.php?action=Email'>Redo Email Test</A> | <A HREF='install.php?action=Registration'>Next: Registration</A>";
		break;
		
	///////////////////// Registration Page //////////////////
	case 'Registration' :
		// Sanity check
		if( $QW['requestButton'] == 'Register Now' && $QW['requestEmail'] )
		{			
			// -- Valid form --
			?><DIV CLASS='QWHeading1'>Registration Complete</DIV>
			<DIV CLASS='QWNormal'>
				Thank you for registering QwikiWiki!  The following email has been sent on your behalf:
			</DIV>
			<BR/><?php
			
			// Compose the message
			$from = "newinstall@qwikiwiki.com";
			$to = "dbarrett@quinthar.com";
			$subject = "QwikiWiki 1.4.1 installed by $QW[requestName]";
			$message = "A new user has installed QwikiWiki 1.4:\n" .
				"   Name: '$QW[requestName]'\n" .
				"   Email: '$QW[requestEmail]'\n" .
				( $QW['sendagent'] ? "   User Agent: '" . $HTTP_SERVER_VARS['HTTP_USER_AGENT'] . "'\n" : "" ) . 
				( $QW['sendsignature'] ? "   Server Signature: '" . strip_tags( $HTTP_SERVER_VARS['SERVER_SIGNATURE'] ) . "'\n" : "" ) .
				( $QW['sendos'] ? "   Server OS: '" . php_uname( ) . "'\n" : "" ) .
				( $QW['sendversion'] ? "   PHP Version: '" . PHP_VERSION . "'\n" : "" ) .
				( $QW['sendsafemode'] ? "   Safe Mode: '" . (ini_get( 'safe_mode' ) ? "On" : "Off") . "'\n" : "" ) .
				( $QW['senduploads'] ? "   File Uploads: '" . (ini_get( 'file_uploads' ) ? "On" : "Off") . "'\n" : "" ) .
				"   Announce List: '" . ($QW['requestAnnounceList'] ? "Yes" : "No") . "'\n" .
				"   Discuss List: '" . ($QW['requestDiscussList'] ? "Yes" : "No") . "'\n" .
				"\n" . 
				"Why are you trying QwikiWiki?\n" . 
				"-----------------------------\n" . 
				$QW['requestWhyQwiki'] . "\n" . 
				"\n" . 
				"What experiences (good or bad) have you had with other wikis?\n" . 
				"-------------------------------------------------------------\n" . 
				$QW['requestOtherWikis'] . "\n" .
				"\n" . 
				"How did you learn about QwikiWiki?\n" . 
				"-------------------------------------------------------------\n" . 
				$QW['requestLearnQwiki'] . "\n";
			
			// Send the email
			@mail( $to, $subject, $message, "From: $from\r\n" );
				
			// Output the results
			?><TABLE CLASS='QWResultBox' ALIGN='center'>
			<TR><TD VALIGN='top'><IMG SRC='exclamationicon.gif'/></TD>
			<TD><?php echo "<PRE>From: $from\n" . 
				"To: $to\n" . 
				"Subject: $subject\n" .
				"-----------------------------------------------\n" .
				$message . "</PRE>" ?>				
			</TD></TR>
			</TABLE>
			<BR/>
			<DIV CLASS='QWNormal'>
				Also, per your request you <B><?php echo ($QW['requestAnnounceList'] ? "will" : "will not" ) ?></B> be
				added to the <A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-announce' TARGET='_blank'>QwikiWiki-Announce</A> mailing list, and <B><?php echo ($QW['requestDiscussList'] ? "will" : "will not" ) ?></B>
				be added to <A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-discuss' TARGET='_blank'>QwikiWiki-Discuss</A>.  Should you ever change your mind, visit <A HREF="http://www.qwikiwiki.com">www.qwikiwiki.com</A>
				for instructions on how to change your settings.
			</DIV>			
			<BR/>
			<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Done'>Click here to finish</A></DIV>		
			<BR/>
			<?php
		}
		else if( $QW['requestButton'] == "Don't Register" )
		{
			// -- Valid form --
			?><DIV CLASS='QWHeading1'>Registration Cancelled</DIV>
			<DIV CLASS='QWNormal'>
				You have opted not to register your installation of QwikiWiki.  Regardless, should
				you ever have any questions or problems with QwikiWiki, please do not hesitate to 
				contact me, David Barrett, at <A HREF='mailto:dbarrett@quinthar.com'>dbarrett@quinthar.com</A>.
			</DIV>
			<BR/>
			<DIV CLASS='QWNormal' ALIGN='center'><A HREF='install.php?action=Done'>Click here to finish</A></DIV>		
			<BR/><?php
		}
		else
		{
			// -- Not a valid form --
			// Output the HTML	
			?><DIV CLASS='QWHeading1'>Register QwikiWiki</DIV>
			<DIV CLASS='QWNormal'>
				Congratulations, if you made it this far you're ready to go.  But before you do, please
				help me out in one respect: while I have no intent of charging for use of QwikiWiki,
				I do like to keep track of who's using it and for what purpose.  So if you could do me the simple
				favor of filling out the following registration form, I'd be very appreciative (and more likely
				to keep improving QwikiWiki over time).  Thanks! -<A HREF='mailto:dbarrett@quinthar.com'>david</A>
			</DIV>
			<BR/><?php
	
			?><FORM CLASS='QWForm' ENCTYPE="multipart/form-data" METHOD="post" ACTION="install.php">
				<INPUT TYPE='hidden' NAME='action' VALUE='Registration'/>
				<TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>Personal Info</TD><TD>Value</TD></TR>
					<TR><TD ALIGN='right'>Your Name:</TD><TD><INPUT TYPE='text' NAME='name' VALUE='<?php echo $QW['requestName'] ?>'/></TD></TR>
					<TR><TD ALIGN='right'>(required) Your Email:</TD><TD><INPUT TYPE='text' NAME='email' VALUE='<?php echo $QW['requestEmail'] ?>'/></TD></TR>
				</TABLE>
				<BR/>
				<TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>Why are you trying QwikiWiki?</TD></TR>
					<TR><TD ALIGN='center'><TEXTAREA NAME="whyqwiki" COLS="60" ROWS="5"><?php echo $QW['requestWhyQwiki'] ?></TEXTAREA></TD></TR>
				</TABLE>
				<BR/>
				<TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>What experiences (good or bad) have you had with other wikis?</TD></TR>
					<TR><TD ALIGN='center'><TEXTAREA NAME="otherwikis" COLS="60" ROWS="5"><?php echo $QW['requestOtherWikis'] ?></TEXTAREA></TD></TR>
				</TABLE>
				<BR/>
				<TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>How did you learn about QwikiWiki?</TD></TR>
					<TR><TD ALIGN='center'><TEXTAREA NAME="learnqwiki" COLS="60" ROWS="5"><?php echo $QW['requestLearnQwiki'] ?></TEXTAREA></TD></TR>
				</TABLE>
				<BR/>
				<DIV ALIGN='center'><INPUT checked TYPE="checkbox" NAME="announcelist"/> Add me to the <A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-announce' TARGET='_blank'>QwikiWiki-Announce</A> mailing list.</DIV>
				<DIV ALIGN='center'><INPUT TYPE="checkbox" NAME="discusslist"/> Add me to the <A HREF='http://lists.sourceforge.net/lists/listinfo/qwikiwiki-discuss' TARGET='_blank'>QwikiWiki-Discuss</A> mailing list.</DIV>
				<BR/>
				<TABLE ALIGN='center' CLASS='QWInnerSection'>
					<TR CLASS='QWInnerSectionTitle'><TD>Send</TD><TD>Your Settings</TD><TD>Value</TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="sendagent"/></TD><TD ALIGN='right'>User Agent:</TD><TD><?php echo $HTTP_SERVER_VARS['HTTP_USER_AGENT'] ?></TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="sendsignature"/></TD><TD ALIGN='right'>Server Signature:</TD><TD><?php echo $HTTP_SERVER_VARS['SERVER_SIGNATURE'] ?></TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="sendos"/></TD><TD ALIGN='right'>Server OS:</TD><TD><?php echo php_uname( ) ?></TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="sendversion"/></TD><TD ALIGN='right'>PHP Version:</TD><TD><?php echo PHP_VERSION  ?></TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="sendsafemode"/></TD><TD ALIGN='right'>Safe Mode:</TD><TD><?php echo (ini_get( 'safe_mode' ) ? "On" : "Off") ?></TD></TR>
					<TR><TD ALIGN='center'><INPUT checked TYPE="checkbox" NAME="senduploads"/></TD><TD ALIGN='right'>File Uploads:</TD><TD><?php echo (ini_get( 'file_uploads' ) ? "On" : "Off") ?></TD></TR>
				</TABLE>
				<BR/>
				<DIV ALIGN='center'><INPUT TYPE="submit" NAME="button" VALUE="Register Now"/><INPUT TYPE="submit" NAME="button" VALUE="Don't Register"/></DIV>
				<BR/>
			</FORM>
			<BR/><?php
		}
		
		// Set the navigation		
		$commandHTML = "<A HREF='install.php?action=Email'>Back: Email Test</A>";
		break;
		
	case 'Done' :
		// -- Valid form --
		?><DIV CLASS='QWHeading1'>Installation Complete</DIV>
		<DIV CLASS='QWNormal'>
			Thank you for installing QwikiWiki!  As a final step, this installation wizard
			will copy a few basic pages into your new <CODE>data/</CODE> directory.  Feel free
			to keep or use the content there as you see fit.  Other than this, you are now all set
			and ready to go.  Click below to start using your new QwikiWiki!
		</DIV>
		<BR/>
		<?php
			// Copy over the seed data
			$dataPath = 'data';
			$installPath = 'installdata';
			$result = "<DIV>Copying from <CODE>$installPath</CODE> to <CODE>$dataPath</CODE>...</DIV>\n";
			$error = false;
			if( ($testResult = testDir( $dataPath )) != "OK" ) { $error=true; $result .= $testResult; }
			else
				if( !is_dir( $installPath ) ) { $error=true; $result .= "<DIV CLASS='QWError'>Error - Missing directory <CODE>$installPath</CODE></DIV>\n"; }
				else
				{
					// Loop across the contents of installdata and manually copy to the data dir
					$installDir = dir( $installPath );
					while( $filename = $installDir->read( ) )
					{
						// Get the paths
						$fromPath = "$installPath/$filename";
						$toPath = "$dataPath/$filename";
						if( is_file( $fromPath ) )
							if( !is_file( $toPath ) )
							{
								// Copy with the web privileges
								$fromFP = fopen( $fromPath, 'rb' );
								$toFP = fopen( $toPath, 'wb' );
								$data = fread( $fromFP, filesize( $fromPath ) );
								fwrite( $toFP, $data );
								fclose( $fromFP );
								fclose( $toFP );
								$result .= "<DIV>Copied <CODE>$fromPath</CODE> to <CODE>$toPath</CODE>\n</DIV>";
							}
							else
							{
								// Collision
								$result .= "<DIV CLASS='QWError'>Cannot copy <CODE>$fromPath</CODE> to <CODE>$toPath</CODE> -- file already exists</DIV>\n";
							}
							
					}
					$installDir->close( );
				}
				
			if( $error ) $result .= "<DIV CLASS='QWError'>Cancelled - Errors prevent finishing installation</DIV>\n";
			else
			{
				// Finish the installation by creating the installation complete lockfile
				touch( "$dataPath/INSTALLCOMPLETE" );
				$result .= "<DIV>Created <CODE>$dataPath/INSTALLCOMPLETE</CODE></DIV>\n";
				$result .= "<DIV>Done - Installation complete.</DIV>\n";
			}
		?>						
		<TABLE CLASS='QWResultBox' ALIGN='center'>
			<TR><TD VALIGN='top'><IMG SRC='exclamationicon.gif'/></TD><TD><?php echo $result ?></TD></TR>
		</TABLE>
		<BR/>
		<?php if( $error ) { 
			// Errors
			$commandHTML = "<A HREF='install.php?action=Done'>Retry</A>";
			?><DIV CLASS='QWNormal' ALIGN='center'>Please resolve above errors to complete installation and <A HREF='install.php?action=Done'>try again</A>.</DIV><?php 
		} else { 
			$commandHTML = "<A HREF='index.php'>Finish</A>";
			?><DIV CLASS='QWNormal' ALIGN='center'><A HREF='index.php'>Installation complete, click here to visit your QwikiWiki!</A></DIV><?php
		} ?>
		<BR/><?php
		
		break;
	
}
?>		
			<DIV CLASS='QWFooterBox' ALIGN='right'> </DIV>
			<DIV CLASS='QWCommandList' ALIGN='right'><?php echo $commandHTML ?></DIV>
			<BR/>	
			<DIV CLASS='QWCommandList' ALIGN='center'>Powered by QwikiWiki v1.4 - <A HREF='http://www.quinthar.com'>www.qwikiwiki.com</A></DIV>
			
		</TD></TR></TABLE>
	</BODY>