<?php 
// login.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.
require_once( "_global.php" );


////////////////////////////////////////////////////////////////////////////////
///////////////////////// Authenticate the User ////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// See if we're not already authenticated
if( !$QW['userIsAuthenticated'] )
{
	// Check the user-supplied password
	$encryptedPassword = md5( $QW['requestPassword'] );
	if( $encryptedPassword == $QW['encryptedPassword'] )
	{
		// Password matches, record it in the cookie, expire in 30 days
		$QW['userIsAuthenticated'] = true;		
		setcookie( "password", $QW['encryptedPassword'], time()+60*60*24*30 );
	}
}

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Test for Success //////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Redirect if the authentication worked
if( $QW['userIsAuthenticated'] )
{			
	// Redirect to the reference page
	QWRedirect( "index.php?page=$QW[page]$QW[URLSuffix]" );
	exit;
}

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Define Template Functions /////////////////////////
////////////////////////////////////////////////////////////////////////////////

// QWTLoginFormatTitle
$QW_TEMPLATE['getTitle'] = "QWTLoginFormatTitle";
function QWTLoginFormatTitle( )
{
	// Output a title
	global $QW_CONFIG;
	return QWCleanQwikiPageName( "Login to $QW_CONFIG[title]" );
}

// QWTLoginInjectBody
$QW_TEMPLATE['injectBody'] = "QWTLoginInjectBody";
function QWTLoginInjectBody( )
{
global $QW, $QW_CONFIG;
	// See if the password was incorrect or never supplied
	if( $QW['requestAction'] == 'Login' )
	{
		// It didn't work, explain why
		if( $QW['requestPassword'] ) $message = "The password you supplied for <B>$QW_CONFIG[title]</B> was incorrect.  Please type the correct password below and click <B>Login</B>.";
		else                         $message = "Please type the password for <B>$QW_CONFIG[title]</B> below and click <B>Login</B>.";
		QWFormatMessage( $message );
	}
		
	// Display the login screen
	?>
		<FORM CLASS='QWForm' ENCTYPE="multipart/form-data" METHOD="get" ACTION="login.php">
			<INPUT TYPE="hidden" NAME="action" VALUE="Login"/>
			<INPUT TYPE="hidden" NAME="page" VALUE="<?php echo $QW['page'] ?>"/>
			<INPUT TYPE="hidden" NAME="debug" VALUE="<?php echo $QW['requestDebug'] ?>"/>
			<INPUT TYPE="hidden" NAME="help" VALUE="<?php echo $QW['requestHelp'] ?>"/>
			<TABLE CLASS='QWInnerSection' ALIGN='center'>
				<TR CLASS='QWInnerSectionTitle'><TD>Password:</TD></TR>
				<TR><TD><INPUT TYPE="password" NAME="password"/><INPUT TYPE='submit' NAME='action' ACTION='search.php' VALUE='Login'/></TD></TR>
			</FORM>
		</TABLE>
		
	<?php 
	QWFormatHelp( "<P>Every QwikiWiki has a password, known only to the administrators.  To login as
		an administrator, simply type the admin password into the <B>Password</B> field and click <B>Login</B>.</P>",
		"login.php?page=$QW[page]" );
}

// QWLoginFormatCommandList
$QW_TEMPLATE['commandList'] = "QWLoginFormatCommandList";
function QWLoginFormatCommandList( )
{	
	// Just go back to the originating page
	global $QW;
	$commandList[] = "<A HREF='index.php?page=$QW[page]$QW[URLSuffix]'>Back to $QW[page]</A>";
	return $commandList;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////// Fill Template ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Include the template
include( $QW_CONFIG['templateFilename'] );

// Output debugging, if requested
if( $QW_CONFIG['enableDebugging'] && $QW['requestDebug'] ) echo QWFormatDebug( );
