<?php 
// recentchanges.php
//
// Copyright 2004, David Barrett.  All Rights Reserved.
//   Email: dbarrett@quinthar.com
//     Web: http://www.quinthar.com
//
// See LICENSE for the complete licensing details.
require_once( "_global.php" );

////////////////////////////////////////////////////////////////////////////////
///////////////////////////////// Disable Caching //////////////////////////////
////////////////////////////////////////////////////////////////////////////////
QWDisableCaching( );

////////////////////////////////////////////////////////////////////////////////
//////////////////////////// Define Template Functions /////////////////////////
////////////////////////////////////////////////////////////////////////////////

// QWTRecentChangesFormatGlobalNav
$QW_TEMPLATE['getGlobalNavPageNameList'] = "QWTRecentChangesFormatGlobalNav";
function QWTRecentChangesFormatGlobalNav( )
{
	// Output from the config file
	global $QW_CONFIG;
	return QWFormatQwikiText( $QW_CONFIG['globalNav'] );
}

// QWTRecentChangesFormatTitle
$QW_TEMPLATE['getTitle'] = "QWTRecentChangesFormatTitle";
function QWTRecentChangesFormatTitle( )
{
	// Output a title
	global $QW;
	return 'Recent Changes';
}

// QWTRecentChangesInjectBody
$QW_TEMPLATE['injectBody'] = "QWTRecentChangesInjectBody";
function QWTRecentChangesInjectBody( )
{
	// Output a table of recently changed pages
	QWFormatHelp( "<P>This page simply lists all pages in the system, sorted by the time since it was last changed.</P>",
	              "recentchanges.php?nothing=nothing" );
	              
	// Get the list and compose 
	$list = QWGetRecentlyChangedQwikiPageNameList( );
	$now = time( );	              
	?><TABLE ALIGN='center' CLASS='QWInnerSection'>
		<TR CLASS='QWInnerSectionTitle'><TD>Page Name:</TD><TD>Last Changed:</TD></TR>
		<?php
			// Loop across the list and output
			foreach( $list as $pageName )
			{
				// Get the path and timestamp
				$path = QWCreateDataPath( $pageName, '.qwiki' );
				$then = filemtime( $path );
				$delta = QWFormatRelativeDate( $now, $then );
				
				// Output the row
				echo "<TR><TD>" . QWFormatQwikiPageName( $pageName ) . "</TD><TD>$delta</TD></TR>\n";
			}
		?>
	</TABLE><?php
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////// Fill Template ///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

// Include the template
include( $QW_CONFIG['templateFilename'] );

// Output debugging, if requested
if( $QW_CONFIG['enableDebugging'] && $QW['requestDebug'] ) echo QWFormatDebug( );

?>